<template>
  <div class="pt-4">
    <SearchInput @search="onSearchInput" />
    <p v-if="total > 0">
      Found a total of <code class="font-weight-black">{{ total }}</code>
      {{ numerus('hit', total) }} for <code class="font-weight-black">{{ query }}</code> in
      <code class="font-weight-black">{{ distinctSheets }}</code> {{ numerus('Sheet', distinctSheets) }} and
      <code class="font-weight-black">{{ distinctManuscripts }}</code> {{ numerus('Manuscript', distinctManuscripts) }}.
    </p>

    <div class="alert alert-secondary" role="alert" v-if="showPlaceholder">
      Please use the form above to enter a and search for a term of your choice.
    </div>

    <SearchResultEmpty v-if="showNoResult" :message="message" />

    <div v-if="loading" class="loading-wrapper py-10">
      <v-progress-circular
        color="primary"
        indeterminate
        size="50"
      />
    </div>

    <SearchResultList
      v-else
      :hit-counter="hitCounter"
      :items="items"
      :message="message"
      :query="query"
      :page="page"
    />

    <div class="mt-5">
      <Pagination
        v-if="distinctSheets > size"
        v-model="page"
        :total-pages="pagesAmount"
        :total="total"
        :per-page="size"
      />
    </div>
  </div>
</template>

<script>
import apiService from '../utilities/api';
import SearchResultEmpty from "./SearchResultEmpty.vue";
import SearchResultList from "./SearchResultList.vue";
import SearchInput from "./SearchInput.vue";
import Keyboard from "./Keyboard.vue";
import Pagination from "./Pagination.vue";

export default {
  components: {
    SearchResultEmpty,
    SearchResultList,
    SearchInput,
    Keyboard,
    Pagination
  },
  data() {
    return {
      distinctManuscripts: 0,
      distinctSheets: 0,
      hitCounter: 0,
      items: [],
      loading: false,
      message: '',
      page: 1,
      query: null,
      size: 5,
      total: 0,
      showPlaceholder: false,
      showNoResult: false,
    };
  },
  watch:{
    page: function(page) {
      this.loading = true;

      const from = this.size * (page - 1);

      this.updateQueryParameter(this.query.trim(), page || 1);

      this.search(this.query.trim(), from, this.size);
    },
  },
  mounted(){
    const page = this.$route.query?.page;

    if(page) {
      this.page = parseInt(page);
    }

    if(this.$route.query?.searchTerm) {
      this.onSearchInput(this.$route.query.searchTerm, this.page);
    } else {
      this.showPlaceholder = true;
    }
  },
  computed: {
    invalid() {
      return this.query.match(/^\s*$/);
    },
    pagesAmount() {
      return this.distinctSheets > 0
        ? Math.ceil(this.distinctSheets / this.size)
        : 1;
    },
  },
  methods: {
    onSearchInput(query, page) {
      this.query = query;
      this.resetList();

      this.showPlaceholder = false;
      this.showNoResult = false;

      this.search(this.query.trim(), 0, this.size);

      this.updateQueryParameter(query, page || 1);

      this.page = page || 1;
    },

    updateQueryParameter(query, page) {
      if(this.$route.query.searchTerm === query && this.$route.query.page === String(page)) {
        return;
      }

      this.$router.push({ query: { ...this.$route.query, searchTerm:query, page:page || 1 } });
    },

    async search(value, from, size) {
      this.hitCounter = from + 1;

      try {
        this.loading = true;

        const searchResponse = await apiService.search(value, from, size);
        const items = searchResponse.hits?.hits;

        if (items) {
          this.items = items.map(x => ({ ...x, searchTerm: value }));

          this.distinctManuscripts = searchResponse.hits?.total?.manifests || 0;
          this.distinctSheets = searchResponse.hits?.total?.value || 0;

          this.total = searchResponse.hits?.total?.matches || 0;
        }

        // Toggle no result message on top of result list
        this.showNoResult = this.total === 0;

        // TODO: make string translable
        if (!this.invalid) this.message = `No search results found for <code>${this.query}</code>.`;
      } catch(error) {
          this.resetList();
          this.showNoResult = true;
          this.message = 'Please enter a valid search term.';
      } finally {
        this.loading = false;
      }
    },

    resetList() {
      this.items = [];
      this.distinctSheets = 0;
      this.total = 0;
    },
    numerus(term, value) {
      return value === 1 ? term : `${term}s`;
    },
    onPageChange() {

    }
  },
};
</script>

<style lang="scss" scoped>
.loading-wrapper {
  text-align: center;
}
</style>
